# -*- coding: utf-8 -*-

##
##    Copyright © 2008-2009 Ordissimo <info@substantiel.fr>
##    Copyright © 2008-2009 Boesch Clément <ubitux@gmail.com>
##
##    This file is part of oMSN.
##
##    oMSN is free software: you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation, either version 3 of the License, or
##    (at your option) any later version.
##
##    oMSN is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with oMSN.  If not, see <http://www.gnu.org/licenses/>.
##

import papyon
import gobject

class AddressBookEvents(papyon.event.AddressBookEventInterface, gobject.GObject):

    ''' Catch addressbook events and update the contact list as well '''

    __gsignals__ = \
    {
        # called when a new contact is to be inserted in the list
        'new-contact' : (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, (object,))
    }

    def on_addressbook_messenger_contact_added(self, contact):
        self.clist.insert_contact(contact)
        pass

    def on_addressbook_contact_deleted(self, contact):
        self.clist.remove_contact(contact)

    def on_addressbook_contact_blocked(self, contact):
        pass

    def on_addressbook_contact_unblocked(self, contact):
        pass

    def on_addressbook_group_added(self, group):
        pass

    def on_addressbook_group_deleted(self, group):
        pass

    def on_addressbook_group_renamed(self, group):
        pass

    def on_addressbook_group_contact_added(self, group, contact):
        pass

    def on_addressbook_group_contact_deleted(self, group, contact):
        pass

    def __init__(self, client):
        papyon.event.AddressBookEventInterface.__init__(self, client)
        gobject.GObject.__init__(self)
        self.__client = client
        self.clist = None


