# -*- coding: utf-8 -*-

##
##    Copyright © 2008-2009 Ordissimo <info@substantiel.fr>
##    Copyright © 2008-2009 Boesch Clément <ubitux@gmail.com>
##
##    This file is part of oMSN.
##
##    oMSN is free software: you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation, either version 3 of the License, or
##    (at your option) any later version.
##
##    oMSN is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with oMSN.  If not, see <http://www.gnu.org/licenses/>.
##

import papyon
import papyon.event
import gobject

class ClientEvents(papyon.event.ClientEventInterface, gobject.GObject):

    __gsignals__ = \
    {
        'state_changed' : (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE,
            (int,)),
        'connect_error' : (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE,
            (str,))
    }

    def on_user_invitation_failed(self, *p):
        print 'user invit failed:', p

    def on_message_undelivered(self, *p):
        print 'message undelivered:', p

    def on_client_error(self, error_type, error):
        self.emit('connect_error', error_type)

    def on_client_state_changed(self, state):
        self.emit('state_changed', state)
        if state == papyon.event.ClientState.OPEN:
            return True
        return False

    def __init__(self, client):
        self._client = client
        papyon.event.ClientEventInterface.__init__(self, client)
        gobject.GObject.__init__(self)
