# -*- coding: utf-8 -*-

##
##    Copyright © 2008-2009 Ordissimo <info@substantiel.fr>
##    Copyright © 2008-2009 Boesch Clément <ubitux@gmail.com>
##
##    This file is part of oMSN.
##
##    oMSN is free software: you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation, either version 3 of the License, or
##    (at your option) any later version.
##
##    oMSN is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with oMSN.  If not, see <http://www.gnu.org/licenses/>.
##

from gl_config import \
        STATUS_NAMES, STATUS_PIC, \
        STATUS_PICS_PATH, STATUS_PIC_NAMES, \
        OFFLINE, INVISIBLE

import gtk
import papyon

''' Papyon contact extension '''

def set_dp(self, filepath):
    self._dp = filepath

@property
def clist_str(self):
    ret_str = self.account if not self.display_name else self.display_name
    if self.memberships & papyon.Membership.BLOCK:
        ret_str = '[%s] %s' % ('Bloqué(e)', ret_str)
    if self.connected:
        ret_str = '%s (%s)' % (ret_str, STATUS_NAMES[self.presence])
    return ret_str

@property
def dp(self):
    try:
        ret = self._dp
    except:
        ret = 'images/others/unknow.png'
    finally:
        return ret

@property
def connected(self):
    return not self.presence in [OFFLINE, INVISIBLE]

@property
def status_pic(self):
    return STATUS_PIC[self.presence]

''' !Papyon contact extension '''

def init_pixbufs():

    ''' Load status pixbuf '''

    for status in STATUS_PIC_NAMES:
        filename = STATUS_PICS_PATH + STATUS_PIC_NAMES[status]
        pic = gtk.Image()
        pic.set_from_file(filename)
        STATUS_PIC[status] = pic.get_pixbuf()

init_pixbufs()

papyon.Contact.set_dp = set_dp
papyon.Contact.clist_str = clist_str
papyon.Contact.dp = dp
papyon.Contact.connected = connected
papyon.Contact.status_pic = status_pic
