# -*- coding: utf-8 -*-

##
##    Copyright © 2008-2009 Ordissimo <info@substantiel.fr>
##    Copyright © 2008-2009 Boesch Clément <ubitux@gmail.com>
##
##    This file is part of oMSN.
##
##    oMSN is free software: you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation, either version 3 of the License, or
##    (at your option) any later version.
##
##    oMSN is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with oMSN.  If not, see <http://www.gnu.org/licenses/>.
##

import gobject
import papyon

from papyon.service.ContentRoaming import ContentRoaming, ContentRoamingState
from gl_config import gl_config

class CRoaming(ContentRoaming):

    def __on_state_changed(self, *args):
        ''' If synchronised, we fetch the saved nickname and the display
            picture '''
        if self.state == ContentRoamingState.SYNCHRONIZED:
            if self.display_name:
                gl_config.nickname = self.display_name
                gobject.idle_add(gl_config.profile.nick_w.set_nickname,
                        self.display_name)
            (type, data) = self.display_picture
            if data:
                gobject.idle_add(gl_config.profile.write_dp, data)

    def __init__(self, sso, address_book):

        ContentRoaming.__init__(self, sso, address_book)
        self.connect('notify::state', self.__on_state_changed)
        self.sync()
