# -*- coding: utf-8 -*-

##
##    Copyright © 2008-2009 Ordissimo <info@substantiel.fr>
##    Copyright © 2008-2009 Boesch Clément <ubitux@gmail.com>
##
##    This file is part of oMSN.
##
##    oMSN is free software: you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation, either version 3 of the License, or
##    (at your option) any later version.
##
##    oMSN is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with oMSN.  If not, see <http://www.gnu.org/licenses/>.
##

import gtk

class ActionButton(gtk.Button):

    ''' A button with an associated icon '''

    def set_label(self, label):

        self.lbl_w.set_text(label)

    def __init__(self, label, stock_id):

        img = gtk.Image()
        img.set_from_stock(stock_id, gtk.ICON_SIZE_BUTTON)
        self.lbl_w = gtk.Label(label)
        box = gtk.HBox(homogeneous=False)
        box.pack_start(img, expand=False)
        box.pack_start(self.lbl_w)
        gtk.Button.__init__(self)
        self.add(box)
