# -*- coding: utf-8 -*-

##
##    Copyright © 2008-2009 Ordissimo <info@substantiel.fr>
##    Copyright © 2008-2009 Boesch Clément <ubitux@gmail.com>
##
##    This file is part of oMSN.
##
##    oMSN is free software: you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation, either version 3 of the License, or
##    (at your option) any later version.
##
##    oMSN is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with oMSN.  If not, see <http://www.gnu.org/licenses/>.
##

import gtk
import gobject

from gui.action_button import ActionButton

class AddContactWin(gtk.Window):

    INFO_STR = 'Veuillez entrer l\'adresse email du ' \
        'contact que vous désirez ajouter'

    __gsignals__ = \
    {
        'add_contact' : (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, (str,))
    }

    def __add_contact(self, widget):
        self.emit('add_contact', self.entry.get_text())
        self.entry.set_text('')
        self.hide()

    def __init__(self):

        gtk.Window.__init__(self)
        self.set_position(gtk.WIN_POS_CENTER_ON_PARENT)
        self.set_default_size(0, 0)
        self.set_resizable(False)
        self.set_border_width(10)
        self.set_modal(True)
        self.set_title('Ajouter un contact')
        self.set_decorated(False)

        # Widgets
        info_lbl = gtk.Label(AddContactWin.INFO_STR)
        self.entry = gtk.Entry()
        add_b = ActionButton('Ajouter ce contact', gtk.STOCK_ADD)
        add_b.connect('clicked', self.__add_contact)
        cancel_b = gtk.Button(stock=gtk.STOCK_CANCEL)
        cancel_b.connect('clicked', lambda w: self.hide())

        # Pack buttons
        buttons = gtk.HBox(homogeneous=False, spacing=5)
        buttons.pack_start(cancel_b,)
        buttons.pack_start(add_b)

        # Pack everything
        box = gtk.VBox(spacing=5)
        box.set_border_width(10)
        box.pack_start(info_lbl)
        box.pack_start(self.entry)
        box.pack_start(buttons)

        frame = gtk.Frame()
        frame.add(box)

        self.entry.set_activates_default(True)

        self.add(frame)
