# -*- coding: utf-8 -*-

##
##    Copyright © 2008-2009 Ordissimo <info@substantiel.fr>
##    Copyright © 2008-2009 Boesch Clément <ubitux@gmail.com>
##
##    This file is part of oMSN.
##
##    oMSN is free software: you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation, either version 3 of the License, or
##    (at your option) any later version.
##
##    oMSN is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with oMSN.  If not, see <http://www.gnu.org/licenses/>.
##

import gtk
import papyon
import gobject

from gui.clist_action_win import CListActionWin
from gui.action_button import ActionButton

class BlockContactWin(CListActionWin):

    STR_BLOCK = 'Bloquer le contact sélectionné'
    STR_UNBLOCK = 'Débloquer le contact sélectionné'

    __gsignals__ = \
    {
        'unblock_contact' : (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, \
                (object,)),
        'block_contact' : (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, \
                (object,))
    }

    def update_button(self, treeview, user_param=None):
        CListActionWin.update_button(self, treeview)
        contact = self.get_selected_contact()
        if contact != None:
            if contact.memberships & papyon.Membership.BLOCK:
                self.button.set_label(BlockContactWin.STR_UNBLOCK)
            else:
                self.button.set_label(BlockContactWin.STR_BLOCK)

    def block_unblock_contact(self, widget):
        contact = self.get_selected_contact()
        if contact != None:
            if contact.memberships & papyon.Membership.BLOCK:
                self.emit('unblock_contact', contact)
            else:
                self.emit('block_contact', contact)
        self.button.set_sensitive(False)

    def __init__(self):
        button = ActionButton('Bloquer le contact sélectionné', \
                gtk.STOCK_STOP)
        CListActionWin.__init__(self, button, '''Sélectionnez ci-dessous \
un contact que vous souhaitez empecher de vous parler.
Vous avez la possibilité de le débloquer avec le même bouton.''',
'Bloquer ou débloquer un contact')
        button.connect('clicked', self.block_unblock_contact)
