# -*- coding: utf-8 -*-

##
##    Copyright © 2008-2009 Ordissimo <info@substantiel.fr>
##    Copyright © 2008-2009 Boesch Clément <ubitux@gmail.com>
##
##    This file is part of oMSN.
##
##    oMSN is free software: you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation, either version 3 of the License, or
##    (at your option) any later version.
##
##    oMSN is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with oMSN.  If not, see <http://www.gnu.org/licenses/>.
##

import gtk
import gobject

from gui.info_box import InfoBox

class NotebookLabel(gtk.HBox):

    def set_label(self, title):
        self.lbl.set_label(title)

    def __init__(self):

        self.lbl = gtk.Label()

        img = gtk.Image()
        img.set_from_stock(gtk.STOCK_CLOSE, gtk.ICON_SIZE_MENU)

        box = gtk.VBox()
        box.pack_start(img)

        self.close_b = gtk.Button()
        self.close_b.add(box)
        self.close_b.set_relief(gtk.RELIEF_NONE)

        gtk.HBox.__init__(self, spacing=3, homogeneous=False)
        self.pack_start(self.lbl, expand=True, fill=True)
        self.pack_start(self.close_b, expand=False)
        self.show_all()

class ChatNotebook(gtk.VBox):

    def blink_lbl(self):
        if not self.__hl:
            return False
        lbl = self.tablbl.lbl
        if self.__blink:
            lbl.set_markup('<span foreground="red"><b>%s</b></span>' %
                    lbl.get_text())
        else:
            lbl.set_markup('<span foreground="red">%s</span>' % lbl.get_text())
        lbl.set_use_markup(True)
        self.__blink = not self.__blink
        self.queue_draw()
        return True

    def set_highlight_nb(self):
        if not self.__hl:
            gobject.timeout_add(500, self.blink_lbl)
        self.__hl = True

    def unset_highlight_nb(self):
        self.__hl = False
        lbl = self.tablbl.lbl
        lbl.set_markup(lbl.get_text())
        lbl.set_use_markup(False)

    def set_label(self, title):
        self.tablbl.set_label(title)

    def __init__(self, notebooks, info_box, chatview):

        self.__hl = False # Highlight
        self.__blink = False # Status while highlight
        self.__notebooks = notebooks
        self.tablbl = NotebookLabel()

        gtk.VBox.__init__(self, homogeneous=False, spacing=5)
        self.set_border_width(5)
        self.pack_start(info_box, expand=False)
        self.pack_start(chatview, expand=True, fill=True)
        self.show_all()

    @property
    def close_button(self):
        return self.tablbl.close_b
