# -*- coding: utf-8 -*-

##
##    Copyright © 2008-2009 Ordissimo <info@substantiel.fr>
##    Copyright © 2008-2009 Boesch Clément <ubitux@gmail.com>
##
##    This file is part of oMSN.
##
##    oMSN is free software: you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation, either version 3 of the License, or
##    (at your option) any later version.
##
##    oMSN is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with oMSN.  If not, see <http://www.gnu.org/licenses/>.
##

import gtk

class ContactListView(gtk.TreeView):

    def _changed(self, *p):
        self.expand_all()

    def __init__(self, model):

        gtk.TreeView.__init__(self, model=model)
        model.connect('row-changed', self._changed)
        self.set_headers_visible(False)
        self.set_property('show-expanders', False)
        self.set_property('level-indentation', 20)

        contact_column = gtk.TreeViewColumn()
        self.append_column(contact_column)

        # Prepare cells (contact and groups)
        pix_cell = gtk.CellRendererPixbuf()
        contact_cell = gtk.CellRendererText()

        # Field association
        contact_column.pack_start(pix_cell)
        contact_column.pack_start(contact_cell)
        contact_column.add_attribute(contact_cell, 'text', 1)
        contact_column.add_attribute(pix_cell, 'pixbuf', 2)

class ContactListFrame(gtk.Frame):

    ''' Pack the ContactListView in a scrolled window
        stuck in a frame '''

    def __init__(self, model):

        swin = gtk.ScrolledWindow()
        swin.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.treeview = ContactListView(model)
        swin.add(self.treeview)
        gtk.Frame.__init__(self)
        self.add(swin)
        self.treeview.expand_all()
