# -*- coding: utf-8 -*-

##
##    Copyright © 2008-2009 Ordissimo <info@substantiel.fr>
##    Copyright © 2008-2009 Boesch Clément <ubitux@gmail.com>
##
##    This file is part of oMSN.
##
##    oMSN is free software: you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation, either version 3 of the License, or
##    (at your option) any later version.
##
##    oMSN is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with oMSN.  If not, see <http://www.gnu.org/licenses/>.
##

import gtk
import gobject

class DPWidget(gtk.HBox):

    def update_dp(self, pic):
        pixbuf = gtk.gdk.pixbuf_new_from_file(pic)
        h = pixbuf.get_height()
        w = pixbuf.get_width()
        if h > 96 or w > 96:
            if h >= w:
                y = 96
                x = w * 96 / h
            elif w > h:
                x = 96
                y = h * 96 / w
            pixbuf = pixbuf.scale_simple(x, y, gtk.gdk.INTERP_BILINEAR)
        self.display_pic.set_from_pixbuf(pixbuf)

    def __init__(self, pic):
        self.dp_button = gtk.Button()
        self.dp_button.set_size_request(100, 100)
        self.display_pic = gtk.Image()
        self.dp_button.add(self.display_pic)
        self.update_dp(pic)
        gtk.HBox.__init__(self)
        self.pack_start(self.dp_button, expand=True, fill=False)
