# -*- coding: utf-8 -*-

##
##    Copyright © 2008-2009 Ordissimo <info@substantiel.fr>
##    Copyright © 2008-2009 Boesch Clément <ubitux@gmail.com>
##
##    This file is part of oMSN.
##
##    oMSN is free software: you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation, either version 3 of the License, or
##    (at your option) any later version.
##
##    oMSN is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with oMSN.  If not, see <http://www.gnu.org/licenses/>.
##

import gtk
import gobject

from smileys import SMILEYS_PIXBUF

class EmbeddedBuffer(gtk.TextBuffer):

    def __replace_smileys(self, len):
        for key in SMILEYS_PIXBUF:
            focus = self.get_start_iter()
            search_params = (key, gtk.TEXT_SEARCH_VISIBLE_ONLY)
            while focus.forward_search(*search_params):
                (start, end) = focus.forward_search(*search_params)
                mark1 = self.create_mark(None, start)
                mark2 = self.create_mark(None, end)
                self.delete(start, end)
                pixbuf = SMILEYS_PIXBUF[key]
                self.insert_pixbuf(self.get_iter_at_mark(mark1), pixbuf)
                if len == 1: return
                focus = self.get_iter_at_mark(mark2)
        return False

    def get_raw_text(self):
        (focus, end) = self.get_bounds()
        text = self.get_slice(focus, end)
        magic = '\xef\xbf\xbc'
        search_params = (magic, gtk.TEXT_SEARCH_VISIBLE_ONLY)
        while focus.forward_search(*search_params):
            (start, end) = focus.forward_search(*search_params)
            text = text.replace(magic, start.get_pixbuf().key, 1)
            focus = end
        return text

    def on_insert_text(self, widget, iter, text, len):
        gobject.idle_add(self.__replace_smileys, len)

    def __init__(self):
        gtk.TextBuffer.__init__(self)
        self.connect('insert-text', self.on_insert_text)
