# -*- coding: utf-8 -*-

##
##    Copyright © 2008-2009 Ordissimo <info@substantiel.fr>
##    Copyright © 2008-2009 Boesch Clément <ubitux@gmail.com>
##
##    This file is part of oMSN.
##
##    oMSN is free software: you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation, either version 3 of the License, or
##    (at your option) any later version.
##
##    oMSN is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with oMSN.  If not, see <http://www.gnu.org/licenses/>.
##

import gtk
import gobject

from gui.action_button import ActionButton
from gui.add_contact_win import AddContactWin
from gui.rm_contact_win import RmContactWin
from gui.block_contact_win import BlockContactWin

class GeneralButtons(gtk.VBox):

    __gsignals__ = \
    {
        'quit' : (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, ()),
        'switch_account' : (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, ())
    }

    def __init__(self):

        gtk.VBox.__init__(self, spacing=3)

        # Related windows
        self._add_contact_win = AddContactWin()
        self._rm_contact_win = RmContactWin()
        self._block_contact_win = BlockContactWin()

        # Buttons
        add_contact_b = ActionButton('Ajouter un contact', gtk.STOCK_ADD)
        rm_contact_b = ActionButton('Supprimer un contact', gtk.STOCK_DELETE)
        block_contact_b = ActionButton('Bloquer ou débloquer un contact', \
                gtk.STOCK_STOP)
        quit_b = ActionButton('Quitter oMSN', gtk.STOCK_QUIT)

        # Link to related action
        add_contact_b.connect('clicked', \
                lambda w: self._add_contact_win.show_all())
        rm_contact_b.connect('clicked', \
                lambda w: self._rm_contact_win.show_all())
        block_contact_b.connect('clicked', \
                lambda w: self._block_contact_win.show_all())
        quit_b.connect('clicked', \
                lambda w: self.emit('quit'))

        # Packaging
        self.pack_start(add_contact_b, expand=False)
        self.pack_start(rm_contact_b, expand=False)
        self.pack_start(block_contact_b, expand=False)
        self.pack_start(quit_b, expand=False)

    @property
    def add_contact_win(self):
        return self._add_contact_win

    @property
    def rm_contact_win(self):
        return self._rm_contact_win

    @property
    def block_contact_win(self):
        return self._block_contact_win
