# -*- coding: utf-8 -*-

##
##    Copyright © 2008-2009 Ordissimo <info@substantiel.fr>
##    Copyright © 2008-2009 Boesch Clément <ubitux@gmail.com>
##
##    This file is part of oMSN.
##
##    oMSN is free software: you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation, either version 3 of the License, or
##    (at your option) any later version.
##
##    oMSN is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with oMSN.  If not, see <http://www.gnu.org/licenses/>.
##

import gtk
import gobject

from gl_config import WIN_TITLE
from gl_fct import quit_omsn
from gl_config import gl_config

from gui.incoming_add_contact_win import IncomingAddContactWin

class LeftPart(gtk.VBox):

    def __init__(self, profile, clistframe, buttons):

        ''' Pack profile + contact list  general buttons '''

        gtk.VBox.__init__(self, spacing=5)
        self.set_border_width(5)
        self.pack_start(profile, expand=False)
        self.pack_start(clistframe, expand=True, fill=True)
        self.pack_start(buttons, expand=False)

        profile.show()
        clistframe.show_all()
        buttons.show_all()

class MainWindow(gtk.Window):

    def on_insert_contact(self):
        print "MainWindow::on_insert_contact"

    def __init__(self, notebook, profile, clistframe, buttons):

        ''' Pack (profile + contact list + general buttons) and chat
            notebooks '''

        gtk.Window.__init__(self)
        self.connect('delete_event', quit_omsn)

        self.set_default_size(800, 600)
        self.set_title(WIN_TITLE)

        left_part = LeftPart(profile, clistframe, buttons)
        left_part.show()
        notebook.show()

        box = gtk.HBox(homogeneous=False)
        box.pack_start(left_part, expand=False)
        box.pack_start(notebook, expand=True, fill=True)
        box.show()

        self.add(box)

        # gl_config.addressbook_events.connect('new-contact', self.popup_incoming_contact)

        buttons.add_contact_win.set_transient_for(self)
        buttons.rm_contact_win.set_transient_for(self)
        buttons.block_contact_win.set_transient_for(self)
        gl_config.emit('connected')

    # def popup_incoming_contact(self, addressbook_events, contact):
    #     win = IncomingAddContactWin(self, contact)
    #     response = win.run()
    #     win.destroy()
    #     return True
