# -*- coding: utf-8 -*-

##
##    Copyright © 2008-2009 Ordissimo <info@substantiel.fr>
##    Copyright © 2008-2009 Boesch Clément <ubitux@gmail.com>
##
##    This file is part of oMSN.
##
##    oMSN is free software: you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation, either version 3 of the License, or
##    (at your option) any later version.
##
##    oMSN is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with oMSN.  If not, see <http://www.gnu.org/licenses/>.
##

import gtk
import gobject

from gui.clist_action_win import CListActionWin
from gui.action_button import ActionButton

class RmContactWin(CListActionWin):

    __gsignals__ = \
    {
        'rm_contact' : (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, (object,))
    }

    def rm_contact(self, widget):
        contact = self.get_selected_contact()
        self.emit('rm_contact', contact)

    def __init__(self):
        button = ActionButton('Supprimer le contact sélectionné', \
                gtk.STOCK_DELETE)
        CListActionWin.__init__(self, button, '''Sélectionnez ci-dessous \
un contact que vous souhaitez voir disparaitre de votre \
liste. Si vous ne bloquez pas ce contact au préalable \
il pourra toujours engager une discussion avec vous.''',
'Supprimer un contact')
        button.connect('clicked', self.rm_contact)

