# -*- coding: utf-8 -*-

##
##    Copyright © 2008-2009 Ordissimo <info@substantiel.fr>
##    Copyright © 2008-2009 Boesch Clément <ubitux@gmail.com>
##
##    This file is part of oMSN.
##
##    oMSN is free software: you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation, either version 3 of the License, or
##    (at your option) any later version.
##
##    oMSN is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with oMSN.  If not, see <http://www.gnu.org/licenses/>.
##

import gtk
import gobject
import math

from smileys import SMILEYS_NAME, SMILEYS_PIXBUF, SMILEYS_ORDER_DISPLAY

class SmileysPopup(gtk.Menu):

    __gsignals__ = \
    {
        'insert_smiley' : (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, (str,))
    }

    def smiley_selected(self, widget, smiley):

        self.emit('insert_smiley', smiley)

    def __init__(self):

        gtk.Menu.__init__(self)
        i = 0
        for key in SMILEYS_ORDER_DISPLAY:
            img = gtk.Image()
            img.set_from_pixbuf(SMILEYS_PIXBUF[key])
            item = gtk.MenuItem()
            item.add(img)
            item.connect('activate', self.smiley_selected, key)
            y = i / 12
            x = i - y * 12
            self.attach(item, x, x + 1, y, y + 1)
            i += 1
        self.show_all()

class SmileysWidget(gtk.Button):

    __gsignals__ = \
    {
        'insert_smiley' : (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, (str,))
    }

    def popup_sm(self, widget, event):

        self.s_popup.popup(None, None, None, event.button, event.time)

    def __init__(self):

        self.s_popup = SmileysPopup()
        img = gtk.Image()
        img.set_from_pixbuf(SMILEYS_PIXBUF[':)'])
        gtk.Button.__init__(self)
        self.set_image(img)
        self.connect('button-press-event', self.popup_sm)
        self.s_popup.connect('insert_smiley', \
                lambda w, s: self.emit('insert_smiley', s))

