# -*- coding: utf-8 -*-

##
##    Copyright © 2008-2009 Ordissimo <info@substantiel.fr>
##    Copyright © 2008-2009 Boesch Clément <ubitux@gmail.com>
##
##    This file is part of oMSN.
##
##    oMSN is free software: you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation, either version 3 of the License, or
##    (at your option) any later version.
##
##    oMSN is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with oMSN.  If not, see <http://www.gnu.org/licenses/>.
##

import gtk
import gobject

from gl_config import \
        STATUS_LIST, STATUS_PIC, STATUS_NAMES, \
        ONLINE, OFFLINE

class StatusList(gtk.ListStore):

    def __init__(self):
        gtk.ListStore.__init__(self, type(ONLINE), gtk.gdk.Pixbuf, str)
        for status in STATUS_LIST:
            if status != OFFLINE:
                self.append((status, STATUS_PIC[status], STATUS_NAMES[status]))

class StatusListWidget(gtk.ComboBox):

    __gsignals__ = \
    {
        'status_changed' : (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE,
            (type(ONLINE),))
    }

    def _update_status(self, widget=None):
        status = self.liststore.get_value(self.get_active_iter(), 0)
        self.emit('status_changed', status)

    def __init__(self):
        self.liststore = StatusList()
        gtk.ComboBox.__init__(self, model=self.liststore)
        status_pic = gtk.CellRendererPixbuf()
        status_name = gtk.CellRendererText()
        self.pack_start(status_pic, expand=False)
        self.pack_start(status_name, expand=False)
        self.add_attribute(status_pic, 'pixbuf', 1)
        self.add_attribute(status_name, 'text', 2)
        self.set_active(0)
        self.connect('changed', self._update_status)
