# -*- coding: utf-8 -*-

##
##    Copyright © 2008-2009 Ordissimo <info@substantiel.fr>
##    Copyright © 2008-2009 Boesch Clément <ubitux@gmail.com>
##
##    This file is part of oMSN.
##
##    oMSN is free software: you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation, either version 3 of the License, or
##    (at your option) any later version.
##
##    oMSN is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with oMSN.  If not, see <http://www.gnu.org/licenses/>.
##

import sha
import papyon
# import imghdr # not used

from shutil import copy
from gl_config import gl_config, OWN_DP_FILE

from gui.profile_box import ProfileBox

class Profile(ProfileBox):

    def _nickname_changed(self, widget, nickname):
        self.client.profile.display_name = nickname
        gl_config.nickname = nickname
        gl_config.cr.store(display_name = nickname)

    def update_dp(self):
        # MSN Object to signal your avatar changement
        avatar = open(OWN_DP_FILE, 'r')
        msn_object = papyon.p2p.MSNObject(
                self.client.profile,
                len(avatar.read()),
                papyon.p2p.MSNObjectType.DISPLAY_PICTURE,
                'avatar',
                '',
                data=avatar)
        self.client.profile.msn_object = msn_object
        # Send the avatar to the Microsoft Network to fetch it next time
        gl_config.cr.store(display_picture = avatar.read())
        avatar.close()

    def write_dp(self, content):
        ''' Avatar is fetched from content roaming, so we write the file and
        update the db '''
        avatar = open(OWN_DP_FILE, 'w')
        avatar.write(content)
        avatar.close()
        self.dp_w.update_dp(OWN_DP_FILE)

    def _dp_changed(self, widget, filename):
        copy(filename, OWN_DP_FILE)
        self.update_dp()

    def _status_changed(self, widget, status):
        self.client.profile.presence = status

    def __init__(self, client, nickname):
        self.client = client
        ProfileBox.__init__(self, nickname)
        self.connect('nickname_changed', self._nickname_changed)
        self.connect('dp_changed', self._dp_changed)
        self.connect('status_changed', self._status_changed)
