# -*- coding: utf-8 -*-

##
##    Copyright © 2008-2009 Ordissimo <info@substantiel.fr>
##    Copyright © 2008-2009 Boesch Clément <ubitux@gmail.com>
##
##    This file is part of oMSN.
##
##    oMSN is free software: you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation, either version 3 of the License, or
##    (at your option) any later version.
##
##    oMSN is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with oMSN.  If not, see <http://www.gnu.org/licenses/>.
##

import gtk

SMILEYS_PIXBUF = {}

SMILEYS_NAME = \
{
    ':)': 'smile',
    ':-)': 'smile',

    ':D': 'big_smile',
    ':-D': 'big_smile',
    ':d': 'big_smile',
    ':-d': 'big_smile',
    ':>': 'big_smile',
    ':->': 'big_smile',

    ';)': 'wink',
    ';-)': 'wink',

    ':o': 'shock',
    ':O': 'shock',
    ':-o': 'shock',
    ':-O': 'shock',

    ':p': 'tongue',
    ':P': 'tongue',
    ':-p': 'tongue',
    ':-P': 'tongue',

    '(h)': 'cool_glasses',
    '(H)': 'cool_glasses',

    ':(': 'sad',
    ':-(': 'sad',
    ':<': 'sad',
    ':-<': 'sad',

    ':\'(': 'crying',

    ':|': 'disapointed',
    ':-|': 'disapointed',

    '(brb)': 'brb',

    ':$': 'embarrassed',
    ':-$': 'embarrassed',

    ':s': 'confused',
    ':-s': 'confused',
    ':S': 'confused',
    ':-S': 'confused',

    ':^)': 'dont_know',

    '*-)': 'think',

    '8-)': 'eye_rolling',

    '|-)': 'tired',

    ':-#': 'quiet',

    '8o|': 'teeth',

    '<:o)': 'party',

    '+o(': 'sick',

    ':@': 'angry',
    ':-@': 'angry',

    '(6)': 'devil',

    '(a)': 'angel',
    '(A)': 'angel',

    '8-|': 'nerd',

    '^o)': 'sarcastic',

    ':-*': 'secret',

    '(y)': 'thumb_up',
    '(Y)': 'thumb_up',

    '(n)': 'thumb_down',
    '(N)': 'thumb_down',

    '(h5)': 'clapping_hands',

    '(yn)': 'finger_cross',

    '({)': 'left_hug',

    '(})': 'right_hug',

    '(z)': 'boy',
    '(Z)': 'boy',

    '(x)': 'girl',
    '(X)': 'girl',

    '(m)': 'msn',
    '(M)': 'msn',

    '(mo)': 'money',

    '(l)': 'heart',
    '(L)': 'heart',

    '(u)': 'broken_heart',
    '(U)': 'broken_heart',

    '(f)': 'rose',
    '(F)': 'rose',

    '(w)': 'dead_rose',
    '(W)': 'dead_rose',

    '(k)': 'kiss',
    '(K)': 'kiss',

    '(g)': 'gift',
    '(G)': 'gift',

    '(^)': 'cake',

    '(ci)': 'cigarette',

    '(%)': 'handcuffs',

    '(b)': 'beer',
    '(B)': 'beer',

    '(d)': 'drink',
    '(D)': 'drink',

    '*help': 'im',
    '*red+u': 'im',
    '*bgca': 'im',
    '*naf': 'im',
    '*mssoc': 'im',
    '*9mil': 'im',
    '*sierra': 'im',
    '*komen': 'im',
    '*unicef': 'im',
    '*hsus': 'im',
    '*one': 'im',
    '*care': 'im',
    '*acs': 'im',
    '*oxfam': 'im',
    '*mod': 'im',
    '*wwf': 'im',

    '(S)': 'moon',

    '(*)': 'star',

    '(#)': 'sun',

    '(r)': 'rainbow',
    '(R)': 'rainbow',

    '(um)': 'umbrella',

    '(ip)': 'island',

    '(st)': 'rain',

    '(li)': 'storm',

    '(pl)': 'plate',

    '(||)': 'bowl',

    '(pi)': 'pizza',

    '(c)': 'coffee',
    '(C)': 'coffee',

    '(@)': 'cat',

    '(&)': 'dog',

    ':[': 'bat',
    ':-[': 'bat',

    '(nah)': 'goat',

    '(sn)': 'snail',

    '(tu)': 'turtle',

    '(bah)': 'sheep',

    '(\'.\')': 'rabbit',

    '(~)': 'film',

    '(8)': 'note',

    '(e)': 'email',
    '(E)': 'email',

    '(p)': 'camera',
    '(P)': 'camera',

    '(i)': 'light',
    '(I)': 'light',

    '(o)': 'clock',
    '(O)': 'clock',

    '(t)': 'phone',
    '(T)': 'phone',

    '(co)': 'computer',

    '(mp)': 'mobile',

    '(xx)': 'xbox',

    '(so)': 'ball',

    '(au)': 'car',

    '(ap)': 'airplane'
}

SMILEYS_ORDER_DISPLAY = \
[
    ':)', ':D', ';)', ':o', ':p', '(h)', ':(', ':\'(', ':|', '(brb)', ':$',
    ':s', ':^)', '*-)', '8-)', '|-)', ':-#', '8o|', '<:o)', '+o(', ':@',
    '(6)', '(a)', '8-|', '^o)', ':-*', '(y)', '(n)', '(h5)', '(yn)', '({)',
    '(})', '(z)', '(x)', '(m)', '(mo)', '(l)', '(u)', '(f)', '(w)', '(k)',
    '(g)', '(^)', '(ci)', '(%)', '(b)', '(d)', '*help', '(S)', '(*)', '(#)',
    '(r)', '(um)', '(ip)', '(st)', '(li)', '(pl)', '(||)', '(pi)', '(c)',
    '(@)', '(&)', ':[', '(nah)', '(sn)', '(tu)', '(bah)', '(\'.\')', '(~)',
    '(8)', '(e)', '(p)', '(i)', '(o)', '(t)', '(co)', '(mp)', '(xx)', '(so)',
    '(au)', '(ap)'
]

def create_smileys_pixbuf():

    print('[+] Load smileys')
    for smiley in SMILEYS_NAME:
        pic = gtk.Image()
        filename = 'images/smileys/%s.png' % SMILEYS_NAME[smiley]
        pic.set_from_file(filename)
        try:
            SMILEYS_PIXBUF[smiley] = pic.get_pixbuf()
            SMILEYS_PIXBUF[smiley].key = smiley
        except:
            print(' |--- Unable to open %s' % filename)

create_smileys_pixbuf()
